Index: drivers/filesystems/btrfs/registry.c
===================================================================
--- drivers/filesystems/btrfs/registry.c	(révision 75772)
+++ drivers/filesystems/btrfs/registry.c	(copie de travail)
@@ -659,44 +788,49 @@
     get_registry_value(h, L"ZlibLevel", REG_DWORD, &mount_zlib_level, sizeof(mount_zlib_level));
     get_registry_value(h, L"FlushInterval", REG_DWORD, &mount_flush_interval, sizeof(mount_flush_interval));
     get_registry_value(h, L"MaxInline", REG_DWORD, &mount_max_inline, sizeof(mount_max_inline));
-    get_registry_value(h, L"Raid5Recalculation", REG_DWORD, &mount_raid5_recalculation, sizeof(mount_raid5_recalculation));
-    get_registry_value(h, L"Raid6Recalculation", REG_DWORD, &mount_raid6_recalculation, sizeof(mount_raid6_recalculation));
     get_registry_value(h, L"SkipBalance", REG_DWORD, &mount_skip_balance, sizeof(mount_skip_balance));
-    
+    get_registry_value(h, L"NoBarrier", REG_DWORD, &mount_no_barrier, sizeof(mount_no_barrier));
+    get_registry_value(h, L"NoTrim", REG_DWORD, &mount_no_trim, sizeof(mount_no_trim));
+    get_registry_value(h, L"ClearCache", REG_DWORD, &mount_clear_cache, sizeof(mount_clear_cache));
+    get_registry_value(h, L"AllowDegraded", REG_DWORD, &mount_allow_degraded, sizeof(mount_allow_degraded));
+    get_registry_value(h, L"Readonly", REG_DWORD, &mount_readonly, sizeof(mount_readonly));
+
+    if (!refresh)
+        get_registry_value(h, L"NoPNP", REG_DWORD, &no_pnp, sizeof(no_pnp));
+
     if (mount_flush_interval == 0)
         mount_flush_interval = 1;
-    
-    if (mount_raid5_recalculation > 1)
-        mount_raid5_recalculation = 1;
-    
-    if (mount_raid6_recalculation > 2)
-        mount_raid6_recalculation = 2;
-    
+
 #ifdef _DEBUG
     get_registry_value(h, L"DebugLogLevel", REG_DWORD, &debug_log_level, sizeof(debug_log_level));
-    
+
     RtlInitUnicodeString(&us, L"LogDevice");
-    
+
     kvfi = NULL;
     kvfilen = 0;
     Status = ZwQueryValueKey(h, &us, KeyValueFullInformation, kvfi, kvfilen, &kvfilen);
-    
+
+    old_log_device = log_device;
+
+    log_device.Length = log_device.MaximumLength = 0;
+    log_device.Buffer = NULL;
+
     if ((Status == STATUS_BUFFER_TOO_SMALL || Status == STATUS_BUFFER_OVERFLOW) && kvfilen > 0) {
         kvfi = ExAllocatePoolWithTag(PagedPool, kvfilen, ALLOC_TAG);
-        
+
         if (!kvfi) {
             ERR("out of memory\n");
             ZwClose(h);
             return;
         }
-        
+
         Status = ZwQueryValueKey(h, &us, KeyValueFullInformation, kvfi, kvfilen, &kvfilen);
-        
+
         if (NT_SUCCESS(Status)) {
             if ((kvfi->Type == REG_SZ || kvfi->Type == REG_EXPAND_SZ) && kvfi->DataLength >= sizeof(WCHAR)) {
-                log_device.Length = log_device.MaximumLength = kvfi->DataLength;
-                log_device.Buffer = ExAllocatePoolWithTag(PagedPool, kvfi->DataLength, ALLOC_TAG);
-                
+                log_device.Length = log_device.MaximumLength = (USHORT)min(0xffff, kvfi->DataLength);
+                log_device.Buffer = ExAllocatePoolWithTag(PagedPool, log_device.MaximumLength, ALLOC_TAG);
+
                 if (!log_device.Buffer) {
                     ERR("out of memory\n");
                     ExFreePool(kvfi);
@@ -704,13 +838,13 @@
                     return;
                 }
 
-                RtlCopyMemory(log_device.Buffer, ((UINT8*)kvfi) + kvfi->DataOffset, kvfi->DataLength);
-                
+                RtlCopyMemory(log_device.Buffer, ((UINT8*)kvfi) + kvfi->DataOffset, log_device.Length);
+
                 if (log_device.Buffer[(log_device.Length / sizeof(WCHAR)) - 1] == 0)
                     log_device.Length -= sizeof(WCHAR);
             } else {
                 ERR("LogDevice was type %u, length %u\n", kvfi->Type, kvfi->DataLength);
-                
+
                 Status = ZwDeleteValueKey(h, &us);
                 if (!NT_SUCCESS(Status)) {
                     ERR("ZwDeleteValueKey returned %08x\n", Status);
@@ -717,34 +851,63 @@
                 }
             }
         }
-        
+
         ExFreePool(kvfi);
     } else if (Status != STATUS_OBJECT_NAME_NOT_FOUND) {
         ERR("ZwQueryValueKey returned %08x\n", Status);
     }
-    
+
+    ExAcquireResourceExclusiveLite(&log_lock, TRUE);
+
+    if (refresh && (log_device.Length != old_log_device.Length || RtlCompareMemory(log_device.Buffer, old_log_device.Buffer, log_device.Length) != log_device.Length ||
+        (!comfo && log_device.Length > 0) || (old_debug_log_level == 0 && debug_log_level > 0) || (old_debug_log_level > 0 && debug_log_level == 0))) {
+        if (comfo)
+            ObDereferenceObject(comfo);
+
+        if (log_handle) {
+            ZwClose(log_handle);
+            log_handle = NULL;
+        }
+
+        comfo = NULL;
+        comdo = NULL;
+
+        if (log_device.Length > 0 && debug_log_level > 0) {
+            Status = IoGetDeviceObjectPointer(&log_device, FILE_WRITE_DATA, &comfo, &comdo);
+            if (!NT_SUCCESS(Status))
+                DbgPrint("IoGetDeviceObjectPointer returned %08x\n", Status);
+        }
+    }
+
+    ExReleaseResourceLite(&log_lock);
+
+    if (old_log_device.Buffer)
+        ExFreePool(old_log_device.Buffer);
+
     RtlInitUnicodeString(&us, L"LogFile");
-    
+
     kvfi = NULL;
     kvfilen = 0;
     Status = ZwQueryValueKey(h, &us, KeyValueFullInformation, kvfi, kvfilen, &kvfilen);
-    
+
+    old_log_file = log_file;
+
     if ((Status == STATUS_BUFFER_TOO_SMALL || Status == STATUS_BUFFER_OVERFLOW) && kvfilen > 0) {
         kvfi = ExAllocatePoolWithTag(PagedPool, kvfilen, ALLOC_TAG);
-        
+
         if (!kvfi) {
             ERR("out of memory\n");
             ZwClose(h);
             return;
         }
-        
+
         Status = ZwQueryValueKey(h, &us, KeyValueFullInformation, kvfi, kvfilen, &kvfilen);
-        
+
         if (NT_SUCCESS(Status)) {
             if ((kvfi->Type == REG_SZ || kvfi->Type == REG_EXPAND_SZ) && kvfi->DataLength >= sizeof(WCHAR)) {
-                log_file.Length = log_file.MaximumLength = kvfi->DataLength;
-                log_file.Buffer = ExAllocatePoolWithTag(PagedPool, kvfi->DataLength, ALLOC_TAG);
-                
+                log_file.Length = log_file.MaximumLength = (USHORT)min(0xffff, kvfi->DataLength);
+                log_file.Buffer = ExAllocatePoolWithTag(PagedPool, log_file.MaximumLength, ALLOC_TAG);
+
                 if (!log_file.Buffer) {
                     ERR("out of memory\n");
                     ExFreePool(kvfi);
@@ -752,13 +915,13 @@
                     return;
                 }
 
-                RtlCopyMemory(log_file.Buffer, ((UINT8*)kvfi) + kvfi->DataOffset, kvfi->DataLength);
-                
+                RtlCopyMemory(log_file.Buffer, ((UINT8*)kvfi) + kvfi->DataOffset, log_file.Length);
+
                 if (log_file.Buffer[(log_file.Length / sizeof(WCHAR)) - 1] == 0)
                     log_file.Length -= sizeof(WCHAR);
             } else {
                 ERR("LogFile was type %u, length %u\n", kvfi->Type, kvfi->DataLength);
-                
+
                 Status = ZwDeleteValueKey(h, &us);
                 if (!NT_SUCCESS(Status)) {
                     ERR("ZwDeleteValueKey returned %08x\n", Status);
@@ -765,11 +928,11 @@
                 }
             }
         }
-        
+
         ExFreePool(kvfi);
     } else if (Status == STATUS_OBJECT_NAME_NOT_FOUND) {
-        Status = ZwSetValueKey(h, &us, 0, REG_SZ, def_log_file, (wcslen(def_log_file) + 1) * sizeof(WCHAR));
-        
+        Status = ZwSetValueKey(h, &us, 0, REG_SZ, def_log_file, (ULONG)(wcslen(def_log_file) + 1) * sizeof(WCHAR));
+
         if (!NT_SUCCESS(Status)) {
             ERR("ZwSetValueKey returned %08x\n", Status);
         }
@@ -776,20 +939,78 @@
     } else {
         ERR("ZwQueryValueKey returned %08x\n", Status);
     }
-    
+
     if (log_file.Length == 0) {
-        log_file.Length = log_file.MaximumLength = wcslen(def_log_file) * sizeof(WCHAR);
+        log_file.Length = log_file.MaximumLength = (UINT16)wcslen(def_log_file) * sizeof(WCHAR);
         log_file.Buffer = ExAllocatePoolWithTag(PagedPool, log_file.MaximumLength, ALLOC_TAG);
-        
+
         if (!log_file.Buffer) {
             ERR("out of memory\n");
             ZwClose(h);
             return;
         }
-        
+
         RtlCopyMemory(log_file.Buffer, def_log_file, log_file.Length);
     }
+
+    ExAcquireResourceExclusiveLite(&log_lock, TRUE);
+
+    if (refresh && (log_file.Length != old_log_file.Length || RtlCompareMemory(log_file.Buffer, old_log_file.Buffer, log_file.Length) != log_file.Length ||
+        (!log_handle && log_file.Length > 0) || (old_debug_log_level == 0 && debug_log_level > 0) || (old_debug_log_level > 0 && debug_log_level == 0))) {
+        if (log_handle) {
+            ZwClose(log_handle);
+            log_handle = NULL;
+        }
+
+        if (!comfo && log_file.Length > 0 && refresh && debug_log_level > 0) {
+            IO_STATUS_BLOCK iosb;
+
+            InitializeObjectAttributes(&oa, &log_file, OBJ_CASE_INSENSITIVE | OBJ_KERNEL_HANDLE, NULL, NULL);
+
+            Status = ZwCreateFile(&log_handle, FILE_WRITE_DATA, &oa, &iosb, NULL, FILE_ATTRIBUTE_NORMAL, FILE_SHARE_READ,
+                                  FILE_OPEN_IF, FILE_NON_DIRECTORY_FILE | FILE_WRITE_THROUGH | FILE_SYNCHRONOUS_IO_ALERT, NULL, 0);
+            if (!NT_SUCCESS(Status)) {
+                DbgPrint("ZwCreateFile returned %08x\n", Status);
+                log_handle = NULL;
+            }
+        }
+    }
+
+    ExReleaseResourceLite(&log_lock);
+
+    if (old_log_file.Buffer)
+        ExFreePool(old_log_file.Buffer);
 #endif
-    
+
     ZwClose(h);
 }
+
+_Function_class_(WORKER_THREAD_ROUTINE)
+#ifdef __REACTOS__
+static void NTAPI registry_work_item(PVOID Parameter) {
+#else
+static void registry_work_item(PVOID Parameter) {
+#endif
+    NTSTATUS Status;
+    HANDLE regh = (HANDLE)Parameter;
+    IO_STATUS_BLOCK iosb;
+
+    TRACE("registry changed\n");
+
+    read_registry(&registry_path, TRUE);
+
+    Status = ZwNotifyChangeKey(regh, NULL, (PVOID)&wqi, (PVOID)DelayedWorkQueue, &iosb, REG_NOTIFY_CHANGE_LAST_SET, TRUE, NULL, 0, TRUE);
+    if (!NT_SUCCESS(Status))
+        ERR("ZwNotifyChangeKey returned %08x\n", Status);
+}
+
+void watch_registry(HANDLE regh) {
+    NTSTATUS Status;
+    IO_STATUS_BLOCK iosb;
+
+    ExInitializeWorkItem(&wqi, registry_work_item, regh);
+
+    Status = ZwNotifyChangeKey(regh, NULL, (PVOID)&wqi, (PVOID)DelayedWorkQueue, &iosb, REG_NOTIFY_CHANGE_LAST_SET, TRUE, NULL, 0, TRUE);
+    if (!NT_SUCCESS(Status))
+        ERR("ZwNotifyChangeKey returned %08x\n", Status);
+}
